/* A Bison parser, made by GNU Bison 3.7.6.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30706

/* Bison version string.  */
#define YYBISON_VERSION "3.7.6"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "cfg_y.y"

/* cfg.y - configuration language */

/* Written 1995-1999 by Werner Almesberger, EPFL-LRC/ICA */

#if HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <limits.h>
#include <stdlib.h>

#include "atm.h"
#include "atmd.h"

#include "proto.h"
#include "io.h"
#include "trace.h"
#include "policy.h"


static RULE *rule;
static SIG_ENTITY *curr_sig = &_entity;

void yyerror(const char *s);
void yywarn(const char *s);
int yylex(void);

static int hex2num(char digit)
{
    if (isdigit(digit)) return digit-'0';
    if (islower(digit)) return toupper(digit)-'A'+10;
    return digit-'A'+10;
}


static void put_address(char *address)
{
    char *mask;

    mask = strchr(address,'/');
    if (mask) *mask++ = 0;
    if (text2atm(address,(struct sockaddr *) &rule->addr,sizeof(rule->addr),
      T2A_SVC | T2A_WILDCARD | T2A_NAME | T2A_LOCAL) < 0) {
	yyerror("invalid address");
	return;
    }
    if (!mask) rule->mask = -1;
    else rule->mask = strtol(mask,NULL,10);
    add_rule(rule);
}


#line 128 "cfg_y.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_CFG_Y_H_INCLUDED
# define YY_YY_CFG_Y_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    TOK_LEVEL = 258,               /* TOK_LEVEL  */
    TOK_DEBUG = 259,               /* TOK_DEBUG  */
    TOK_INFO = 260,                /* TOK_INFO  */
    TOK_WARN = 261,                /* TOK_WARN  */
    TOK_ERROR = 262,               /* TOK_ERROR  */
    TOK_FATAL = 263,               /* TOK_FATAL  */
    TOK_SIG = 264,                 /* TOK_SIG  */
    TOK_UNI30 = 265,               /* TOK_UNI30  */
    TOK_UNI31 = 266,               /* TOK_UNI31  */
    TOK_UNI40 = 267,               /* TOK_UNI40  */
    TOK_Q2963_1 = 268,             /* TOK_Q2963_1  */
    TOK_SAAL = 269,                /* TOK_SAAL  */
    TOK_VC = 270,                  /* TOK_VC  */
    TOK_IO = 271,                  /* TOK_IO  */
    TOK_MODE = 272,                /* TOK_MODE  */
    TOK_USER = 273,                /* TOK_USER  */
    TOK_NET = 274,                 /* TOK_NET  */
    TOK_SWITCH = 275,              /* TOK_SWITCH  */
    TOK_VPCI = 276,                /* TOK_VPCI  */
    TOK_ITF = 277,                 /* TOK_ITF  */
    TOK_PCR = 278,                 /* TOK_PCR  */
    TOK_TRACE = 279,               /* TOK_TRACE  */
    TOK_POLICY = 280,              /* TOK_POLICY  */
    TOK_ALLOW = 281,               /* TOK_ALLOW  */
    TOK_REJECT = 282,              /* TOK_REJECT  */
    TOK_ENTITY = 283,              /* TOK_ENTITY  */
    TOK_DEFAULT = 284,             /* TOK_DEFAULT  */
    TOK_NUMBER = 285,              /* TOK_NUMBER  */
    TOK_MAX_RATE = 286,            /* TOK_MAX_RATE  */
    TOK_DUMP_DIR = 287,            /* TOK_DUMP_DIR  */
    TOK_LOGFILE = 288,             /* TOK_LOGFILE  */
    TOK_QOS = 289,                 /* TOK_QOS  */
    TOK_FROM = 290,                /* TOK_FROM  */
    TOK_TO = 291,                  /* TOK_TO  */
    TOK_ROUTE = 292,               /* TOK_ROUTE  */
    TOK_PVC = 293                  /* TOK_PVC  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define TOK_LEVEL 258
#define TOK_DEBUG 259
#define TOK_INFO 260
#define TOK_WARN 261
#define TOK_ERROR 262
#define TOK_FATAL 263
#define TOK_SIG 264
#define TOK_UNI30 265
#define TOK_UNI31 266
#define TOK_UNI40 267
#define TOK_Q2963_1 268
#define TOK_SAAL 269
#define TOK_VC 270
#define TOK_IO 271
#define TOK_MODE 272
#define TOK_USER 273
#define TOK_NET 274
#define TOK_SWITCH 275
#define TOK_VPCI 276
#define TOK_ITF 277
#define TOK_PCR 278
#define TOK_TRACE 279
#define TOK_POLICY 280
#define TOK_ALLOW 281
#define TOK_REJECT 282
#define TOK_ENTITY 283
#define TOK_DEFAULT 284
#define TOK_NUMBER 285
#define TOK_MAX_RATE 286
#define TOK_DUMP_DIR 287
#define TOK_LOGFILE 288
#define TOK_QOS 289
#define TOK_FROM 290
#define TOK_TO 291
#define TOK_ROUTE 292
#define TOK_PVC 293

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 58 "cfg_y.y"

    int num;
    char *str;
    struct sockaddr_atmpvc pvc;

#line 263 "cfg_y.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_CFG_Y_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_TOK_LEVEL = 3,                  /* TOK_LEVEL  */
  YYSYMBOL_TOK_DEBUG = 4,                  /* TOK_DEBUG  */
  YYSYMBOL_TOK_INFO = 5,                   /* TOK_INFO  */
  YYSYMBOL_TOK_WARN = 6,                   /* TOK_WARN  */
  YYSYMBOL_TOK_ERROR = 7,                  /* TOK_ERROR  */
  YYSYMBOL_TOK_FATAL = 8,                  /* TOK_FATAL  */
  YYSYMBOL_TOK_SIG = 9,                    /* TOK_SIG  */
  YYSYMBOL_TOK_UNI30 = 10,                 /* TOK_UNI30  */
  YYSYMBOL_TOK_UNI31 = 11,                 /* TOK_UNI31  */
  YYSYMBOL_TOK_UNI40 = 12,                 /* TOK_UNI40  */
  YYSYMBOL_TOK_Q2963_1 = 13,               /* TOK_Q2963_1  */
  YYSYMBOL_TOK_SAAL = 14,                  /* TOK_SAAL  */
  YYSYMBOL_TOK_VC = 15,                    /* TOK_VC  */
  YYSYMBOL_TOK_IO = 16,                    /* TOK_IO  */
  YYSYMBOL_TOK_MODE = 17,                  /* TOK_MODE  */
  YYSYMBOL_TOK_USER = 18,                  /* TOK_USER  */
  YYSYMBOL_TOK_NET = 19,                   /* TOK_NET  */
  YYSYMBOL_TOK_SWITCH = 20,                /* TOK_SWITCH  */
  YYSYMBOL_TOK_VPCI = 21,                  /* TOK_VPCI  */
  YYSYMBOL_TOK_ITF = 22,                   /* TOK_ITF  */
  YYSYMBOL_TOK_PCR = 23,                   /* TOK_PCR  */
  YYSYMBOL_TOK_TRACE = 24,                 /* TOK_TRACE  */
  YYSYMBOL_TOK_POLICY = 25,                /* TOK_POLICY  */
  YYSYMBOL_TOK_ALLOW = 26,                 /* TOK_ALLOW  */
  YYSYMBOL_TOK_REJECT = 27,                /* TOK_REJECT  */
  YYSYMBOL_TOK_ENTITY = 28,                /* TOK_ENTITY  */
  YYSYMBOL_TOK_DEFAULT = 29,               /* TOK_DEFAULT  */
  YYSYMBOL_TOK_NUMBER = 30,                /* TOK_NUMBER  */
  YYSYMBOL_TOK_MAX_RATE = 31,              /* TOK_MAX_RATE  */
  YYSYMBOL_TOK_DUMP_DIR = 32,              /* TOK_DUMP_DIR  */
  YYSYMBOL_TOK_LOGFILE = 33,               /* TOK_LOGFILE  */
  YYSYMBOL_TOK_QOS = 34,                   /* TOK_QOS  */
  YYSYMBOL_TOK_FROM = 35,                  /* TOK_FROM  */
  YYSYMBOL_TOK_TO = 36,                    /* TOK_TO  */
  YYSYMBOL_TOK_ROUTE = 37,                 /* TOK_ROUTE  */
  YYSYMBOL_TOK_PVC = 38,                   /* TOK_PVC  */
  YYSYMBOL_39_ = 39,                       /* '{'  */
  YYSYMBOL_40_ = 40,                       /* '}'  */
  YYSYMBOL_YYACCEPT = 41,                  /* $accept  */
  YYSYMBOL_all = 42,                       /* all  */
  YYSYMBOL_global = 43,                    /* global  */
  YYSYMBOL_local = 44,                     /* local  */
  YYSYMBOL_item = 45,                      /* item  */
  YYSYMBOL_entity = 46,                    /* entity  */
  YYSYMBOL_47_1 = 47,                      /* $@1  */
  YYSYMBOL_opt_options = 48,               /* opt_options  */
  YYSYMBOL_options = 49,                   /* options  */
  YYSYMBOL_option = 50,                    /* option  */
  YYSYMBOL_sig = 51,                       /* sig  */
  YYSYMBOL_sig_items = 52,                 /* sig_items  */
  YYSYMBOL_saal = 53,                      /* saal  */
  YYSYMBOL_saal_items = 54,                /* saal_items  */
  YYSYMBOL_io = 55,                        /* io  */
  YYSYMBOL_io_items = 56,                  /* io_items  */
  YYSYMBOL_debug = 57,                     /* debug  */
  YYSYMBOL_debug_items = 58,               /* debug_items  */
  YYSYMBOL_policy = 59,                    /* policy  */
  YYSYMBOL_policy_items = 60,              /* policy_items  */
  YYSYMBOL_sig_item = 61,                  /* sig_item  */
  YYSYMBOL_saal_item = 62,                 /* saal_item  */
  YYSYMBOL_io_item = 63,                   /* io_item  */
  YYSYMBOL_debug_item = 64,                /* debug_item  */
  YYSYMBOL_opt_trace_size = 65,            /* opt_trace_size  */
  YYSYMBOL_level = 66,                     /* level  */
  YYSYMBOL_mode = 67,                      /* mode  */
  YYSYMBOL_policy_item = 68,               /* policy_item  */
  YYSYMBOL_69_2 = 69,                      /* $@2  */
  YYSYMBOL_action = 70,                    /* action  */
  YYSYMBOL_direction = 71                  /* direction  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  53
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   108

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  41
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  31
/* YYNRULES -- Number of rules.  */
#define YYNRULES  79
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  117

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   293


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    39,     2,    40,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,    79,    79,    82,    83,    86,    87,   111,   115,   116,
     117,   118,   119,   124,   123,   145,   146,   149,   150,   154,
     158,   159,   163,   167,   181,   188,   189,   192,   193,   197,
     198,   201,   202,   206,   207,   210,   211,   215,   216,   219,
     220,   224,   225,   228,   229,   233,   239,   243,   252,   261,
     270,   279,   284,   288,   296,   300,   304,   309,   313,   320,
     324,   329,   333,   340,   343,   350,   354,   358,   362,   366,
     373,   377,   381,   388,   393,   392,   401,   405,   412,   417
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "TOK_LEVEL",
  "TOK_DEBUG", "TOK_INFO", "TOK_WARN", "TOK_ERROR", "TOK_FATAL", "TOK_SIG",
  "TOK_UNI30", "TOK_UNI31", "TOK_UNI40", "TOK_Q2963_1", "TOK_SAAL",
  "TOK_VC", "TOK_IO", "TOK_MODE", "TOK_USER", "TOK_NET", "TOK_SWITCH",
  "TOK_VPCI", "TOK_ITF", "TOK_PCR", "TOK_TRACE", "TOK_POLICY", "TOK_ALLOW",
  "TOK_REJECT", "TOK_ENTITY", "TOK_DEFAULT", "TOK_NUMBER", "TOK_MAX_RATE",
  "TOK_DUMP_DIR", "TOK_LOGFILE", "TOK_QOS", "TOK_FROM", "TOK_TO",
  "TOK_ROUTE", "TOK_PVC", "'{'", "'}'", "$accept", "all", "global",
  "local", "item", "entity", "$@1", "opt_options", "options", "option",
  "sig", "sig_items", "saal", "saal_items", "io", "io_items", "debug",
  "debug_items", "policy", "policy_items", "sig_item", "saal_item",
  "io_item", "debug_item", "opt_trace_size", "level", "mode",
  "policy_item", "$@2", "action", "direction", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   123,
     125
};
#endif

#define YYPACT_NINF (-31)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int8 yypact[] =
{
      53,    69,     1,    -3,    -1,    -2,     0,    11,   -16,    53,
     -31,   -31,   -31,   -31,   -31,   -31,    69,   -15,   -31,   -31,
      28,   -31,   -31,    69,   -31,   -31,   -31,   -31,    46,   -31,
     -13,    80,   -31,   -31,    69,    16,   -31,   -31,    69,   -18,
      -6,   -31,   -31,    20,   -31,   -31,    69,   -31,   -31,    19,
     -31,   -31,   -31,   -31,   -10,   -31,   -16,   -31,   -31,   -31,
     -31,     2,    28,   -31,   -31,   -31,   -31,   -31,     8,     4,
      80,   -31,     7,    16,   -31,   -31,   -31,     9,    20,   -31,
      10,    19,   -30,   -31,   -31,   -31,   -31,    23,   -31,   -31,
     -31,   -31,   -31,   -31,   -31,   -31,   -31,   -31,   -31,    31,
     -31,    51,   -31,    46,    49,   -31,   -31,   -31,   -31,    15,
      51,   -31,    36,   -31,   -31,    54,   -31
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       3,     0,     0,     0,     0,     0,     0,     0,     5,     3,
      65,    66,    67,    68,    69,     7,     0,    63,    60,    61,
      39,    11,    37,     0,    47,    48,    49,    50,     0,    51,
       0,    27,     8,    25,     0,    31,     9,    29,     0,     0,
       0,    58,    57,    35,    10,    33,     0,    76,    77,    43,
      12,    41,    74,     1,     0,     2,     5,     4,    59,    64,
      62,     0,    39,    45,    70,    71,    72,    52,     0,     0,
      27,    53,     0,    31,    54,    55,    56,     0,    35,    73,
       0,    43,     0,    13,     6,    38,    40,     0,    26,    28,
      30,    32,    34,    36,    42,    44,    78,    79,    75,    15,
      46,    17,    14,     0,     0,    24,    22,    21,    23,     0,
      17,    20,     0,    16,    18,     0,    19
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -31,   -31,    72,    30,   -31,   -31,   -31,   -31,   -23,   -31,
     -31,    24,   -31,    22,   -31,    18,   -31,    27,   -31,    17,
      97,    98,    99,   101,   -31,    25,     3,   102,   -31,   -31,
     -31
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
       0,     7,     8,    55,     9,    56,    99,   102,   109,   110,
      32,    69,    36,    72,    44,    77,    21,    61,    50,    80,
      70,    73,    78,    62,    60,    15,    67,    81,    82,    52,
      98
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int8 yytable[] =
{
      23,    38,    34,    46,    16,    96,    97,    24,    25,    26,
      27,    53,    54,    39,    28,    59,    29,    68,    30,    34,
      75,    40,    46,    38,    76,    17,    47,    48,    83,    41,
      87,    16,    42,    18,    19,    39,    31,    43,    35,    49,
      20,    58,    85,    40,    88,    47,    48,    90,    63,    92,
      94,    41,    17,   100,    42,   113,     1,     2,   115,    71,
      18,    19,     3,    74,    64,    65,    66,     4,   103,     5,
     101,    79,   104,    10,    11,    12,    13,    14,     6,   112,
     105,    57,   106,    23,   116,   107,    84,   114,   108,    86,
      24,    25,    26,    27,    89,    91,    93,    28,    95,    29,
      33,    30,    37,    22,    45,     0,   111,     0,    51
};

static const yytype_int8 yycheck[] =
{
       3,     3,     3,     3,     3,    35,    36,    10,    11,    12,
      13,     0,    28,    15,    17,    30,    19,    30,    21,     3,
      38,    23,     3,     3,    30,    24,    26,    27,    38,    31,
      22,     3,    34,    32,    33,    15,    39,    39,    39,    39,
      39,    16,    40,    23,    40,    26,    27,    40,    23,    40,
      40,    31,    24,    30,    34,    40,     3,     4,    22,    34,
      32,    33,     9,    38,    18,    19,    20,    14,    17,    16,
      39,    46,    21,     4,     5,     6,     7,     8,    25,    30,
      29,     9,    31,     3,    30,    34,    56,   110,    37,    62,
      10,    11,    12,    13,    70,    73,    78,    17,    81,    19,
       3,    21,     4,     2,     5,    -1,   103,    -1,     6
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,     3,     4,     9,    14,    16,    25,    42,    43,    45,
       4,     5,     6,     7,     8,    66,     3,    24,    32,    33,
      39,    57,    64,     3,    10,    11,    12,    13,    17,    19,
      21,    39,    51,    61,     3,    39,    53,    62,     3,    15,
      23,    31,    34,    39,    55,    63,     3,    26,    27,    39,
      59,    68,    70,     0,    28,    44,    46,    43,    66,    30,
      65,    58,    64,    66,    18,    19,    20,    67,    30,    52,
      61,    66,    54,    62,    66,    38,    30,    56,    63,    66,
      60,    68,    69,    38,    44,    40,    58,    22,    40,    52,
      40,    54,    40,    56,    40,    60,    35,    36,    71,    47,
      30,    39,    48,    17,    21,    29,    31,    34,    37,    49,
      50,    67,    30,    40,    49,    22,    30
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int8 yyr1[] =
{
       0,    41,    42,    43,    43,    44,    44,    45,    45,    45,
      45,    45,    45,    47,    46,    48,    48,    49,    49,    50,
      50,    50,    50,    50,    50,    51,    51,    52,    52,    53,
      53,    54,    54,    55,    55,    56,    56,    57,    57,    58,
      58,    59,    59,    60,    60,    61,    61,    61,    61,    61,
      61,    61,    61,    62,    63,    63,    63,    63,    63,    64,
      64,    64,    64,    65,    65,    66,    66,    66,    66,    66,
      67,    67,    67,    68,    69,    68,    70,    70,    71,    71
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     2,     0,     2,     0,     2,     2,     2,     2,
       2,     2,     2,     0,     4,     0,     3,     0,     2,     4,
       2,     1,     1,     1,     1,     1,     3,     0,     2,     1,
       3,     0,     2,     1,     3,     0,     2,     1,     3,     0,
       2,     1,     3,     0,     2,     2,     4,     1,     1,     1,
       1,     1,     2,     2,     2,     2,     2,     1,     1,     2,
       1,     1,     2,     0,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     0,     3,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 6: /* local: entity local  */
#line 88 "cfg_y.y"
        {
	    if (!curr_sig->uni)
		curr_sig->uni =
#if defined(UNI30) || defined(DYNAMIC_UNI)
		  S_UNI30
#endif
#ifdef UNI31
		  S_UNI31
#ifdef ALLOW_UNI30
		  | S_UNI30
#endif
#endif
#ifdef UNI40
		  S_UNI40
#ifdef Q2963_1
		  | S_Q2963_1
#endif
#endif
		  ;
	}
#line 1422 "cfg_y.c"
    break;

  case 7: /* item: TOK_LEVEL level  */
#line 112 "cfg_y.y"
        {
	    set_verbosity(NULL,(yyvsp[0].num));
	}
#line 1430 "cfg_y.c"
    break;

  case 13: /* $@1: %empty  */
#line 124 "cfg_y.y"
        {
	    SIG_ENTITY *sig,**walk;

	    if (atmpvc_addr_in_use(_entity.signaling_pvc))
		yyerror("can't use  io vc  and  entity ...  in the same "
		  "configuration");
	    if (entities == &_entity) entities = NULL;
	    for (sig = entities; sig; sig = sig->next)
		if (atm_equal((struct sockaddr *) &sig->signaling_pvc,
		  (struct sockaddr *) &(yyvsp[0].pvc),0,0))
		    yyerror("duplicate PVC address");
	    curr_sig = alloc_t(SIG_ENTITY);
	    *curr_sig = _entity;
	    curr_sig->signaling_pvc = (yyvsp[0].pvc);
	    curr_sig->next = NULL;
	    for (walk = &entities; *walk; walk = &(*walk)->next);
	    *walk = curr_sig;
	}
#line 1453 "cfg_y.c"
    break;

  case 19: /* option: TOK_VPCI TOK_NUMBER TOK_ITF TOK_NUMBER  */
#line 155 "cfg_y.y"
        {
	    enter_vpci(curr_sig,(yyvsp[-2].num),(yyvsp[0].num));
	}
#line 1461 "cfg_y.c"
    break;

  case 21: /* option: TOK_QOS  */
#line 160 "cfg_y.y"
        {
	    curr_sig->sig_qos = (yyvsp[0].str);
	}
#line 1469 "cfg_y.c"
    break;

  case 22: /* option: TOK_MAX_RATE  */
#line 164 "cfg_y.y"
        {
	    curr_sig->max_rate = (yyvsp[0].num);
	}
#line 1477 "cfg_y.c"
    break;

  case 23: /* option: TOK_ROUTE  */
#line 168 "cfg_y.y"
        {
	     struct sockaddr_atmsvc addr;
	     char *mask;

	    mask = strchr((yyvsp[0].str),'/');
	    if (mask) *mask++ = 0;
	    if (text2atm((yyvsp[0].str),(struct sockaddr *) &addr,sizeof(addr),
	    T2A_SVC | T2A_WILDCARD | T2A_NAME | T2A_LOCAL) < 0) {
		yyerror("invalid address");
		YYABORT;
	    }
	    add_route(curr_sig,&addr,mask ? strtol(mask,NULL,10) : INT_MAX);
	}
#line 1495 "cfg_y.c"
    break;

  case 24: /* option: TOK_DEFAULT  */
#line 182 "cfg_y.y"
        {
	    add_route(curr_sig,NULL,0);
	}
#line 1503 "cfg_y.c"
    break;

  case 45: /* sig_item: TOK_LEVEL level  */
#line 234 "cfg_y.y"
        {
	    set_verbosity("UNI",(yyvsp[0].num));
	    set_verbosity("KERNEL",(yyvsp[0].num));
	    set_verbosity("SAP",(yyvsp[0].num));
	}
#line 1513 "cfg_y.c"
    break;

  case 46: /* sig_item: TOK_VPCI TOK_NUMBER TOK_ITF TOK_NUMBER  */
#line 240 "cfg_y.y"
        {
	    enter_vpci(curr_sig,(yyvsp[-2].num),(yyvsp[0].num));
	}
#line 1521 "cfg_y.c"
    break;

  case 47: /* sig_item: TOK_UNI30  */
#line 244 "cfg_y.y"
        {
#if defined(UNI30) || defined(ALLOW_UNI30) || defined(DYNAMIC_UNI)
	    if (curr_sig->uni & ~S_UNI31) yyerror("UNI mode is already set");
	    curr_sig->uni |= S_UNI30;
#else
	    yyerror("Sorry, not supported yet");
#endif
	}
#line 1534 "cfg_y.c"
    break;

  case 48: /* sig_item: TOK_UNI31  */
#line 253 "cfg_y.y"
        {
#if defined(UNI31) || defined(ALLOW_UNI30) || defined(DYNAMIC_UNI)
	    if (curr_sig->uni & ~S_UNI30) yyerror("UNI mode is already set");
	    curr_sig->uni |= S_UNI31;
#else
	    yyerror("Sorry, not supported yet");
#endif
	}
#line 1547 "cfg_y.c"
    break;

  case 49: /* sig_item: TOK_UNI40  */
#line 262 "cfg_y.y"
        {
#if defined(UNI40) || defined(DYNAMIC_UNI)
	    if (curr_sig->uni) yyerror("UNI mode is already set");
	    curr_sig->uni = S_UNI40;
#else
	    yyerror("Sorry, not supported yet");
#endif
	}
#line 1560 "cfg_y.c"
    break;

  case 50: /* sig_item: TOK_Q2963_1  */
#line 271 "cfg_y.y"
        {
#if defined(Q2963_1) || defined(DYNAMIC_UNI)
	    if (!(curr_sig->uni & S_UNI40)) yyerror("Incompatible UNI mode");
	    curr_sig->uni |= S_Q2963_1;
#else
	    yyerror("Sorry, not supported yet");
#endif
	}
#line 1573 "cfg_y.c"
    break;

  case 51: /* sig_item: TOK_NET  */
#line 280 "cfg_y.y"
        {
	    yywarn("sig net  is obsolete, please use  sig mode net  instead");
	    curr_sig->mode = sm_net;
	}
#line 1582 "cfg_y.c"
    break;

  case 53: /* saal_item: TOK_LEVEL level  */
#line 289 "cfg_y.y"
        {
	    set_verbosity("SSCF",(yyvsp[0].num));
	    set_verbosity("SSCOP",(yyvsp[0].num));
	}
#line 1591 "cfg_y.c"
    break;

  case 54: /* io_item: TOK_LEVEL level  */
#line 297 "cfg_y.y"
        {
	    set_verbosity("IO",(yyvsp[0].num));
	}
#line 1599 "cfg_y.c"
    break;

  case 55: /* io_item: TOK_VC TOK_PVC  */
#line 301 "cfg_y.y"
        {
	    curr_sig->signaling_pvc = (yyvsp[0].pvc);
	}
#line 1607 "cfg_y.c"
    break;

  case 56: /* io_item: TOK_PCR TOK_NUMBER  */
#line 305 "cfg_y.y"
        {
	    yywarn("io pcr  is obsolete, please use  io qos  instead");
	    curr_sig->sig_pcr = (yyvsp[0].num);
	}
#line 1616 "cfg_y.c"
    break;

  case 57: /* io_item: TOK_QOS  */
#line 310 "cfg_y.y"
        {
	    curr_sig->sig_qos = (yyvsp[0].str);
	}
#line 1624 "cfg_y.c"
    break;

  case 58: /* io_item: TOK_MAX_RATE  */
#line 314 "cfg_y.y"
        {
	    curr_sig->max_rate = (yyvsp[0].num);
	}
#line 1632 "cfg_y.c"
    break;

  case 59: /* debug_item: TOK_LEVEL level  */
#line 321 "cfg_y.y"
        {
	    set_verbosity(NULL,(yyvsp[0].num));
	}
#line 1640 "cfg_y.c"
    break;

  case 60: /* debug_item: TOK_DUMP_DIR  */
#line 325 "cfg_y.y"
        {
	    dump_dir = (yyvsp[0].str);
	    if (!trace_size) trace_size = DEFAULT_TRACE_SIZE;
	}
#line 1649 "cfg_y.c"
    break;

  case 61: /* debug_item: TOK_LOGFILE  */
#line 330 "cfg_y.y"
        {
	    set_logfile((yyvsp[0].str));
	}
#line 1657 "cfg_y.c"
    break;

  case 62: /* debug_item: TOK_TRACE opt_trace_size  */
#line 334 "cfg_y.y"
        {
	    trace_size = (yyvsp[0].num);
	}
#line 1665 "cfg_y.c"
    break;

  case 63: /* opt_trace_size: %empty  */
#line 340 "cfg_y.y"
        {
	    (yyval.num) = DEFAULT_TRACE_SIZE;
	}
#line 1673 "cfg_y.c"
    break;

  case 64: /* opt_trace_size: TOK_NUMBER  */
#line 344 "cfg_y.y"
        {
	    (yyval.num) = (yyvsp[0].num);
	}
#line 1681 "cfg_y.c"
    break;

  case 65: /* level: TOK_DEBUG  */
#line 351 "cfg_y.y"
        {
	    (yyval.num) = DIAG_DEBUG;
	}
#line 1689 "cfg_y.c"
    break;

  case 66: /* level: TOK_INFO  */
#line 355 "cfg_y.y"
        {
	    (yyval.num) = DIAG_INFO;
	}
#line 1697 "cfg_y.c"
    break;

  case 67: /* level: TOK_WARN  */
#line 359 "cfg_y.y"
        {
	    (yyval.num) = DIAG_WARN;
	}
#line 1705 "cfg_y.c"
    break;

  case 68: /* level: TOK_ERROR  */
#line 363 "cfg_y.y"
        {
	    (yyval.num) = DIAG_ERROR;
	}
#line 1713 "cfg_y.c"
    break;

  case 69: /* level: TOK_FATAL  */
#line 367 "cfg_y.y"
        {
	    (yyval.num) = DIAG_FATAL;
	}
#line 1721 "cfg_y.c"
    break;

  case 70: /* mode: TOK_USER  */
#line 374 "cfg_y.y"
        {
	    curr_sig->mode = sm_user;
	}
#line 1729 "cfg_y.c"
    break;

  case 71: /* mode: TOK_NET  */
#line 378 "cfg_y.y"
        {
	    curr_sig->mode = sm_net;
	}
#line 1737 "cfg_y.c"
    break;

  case 72: /* mode: TOK_SWITCH  */
#line 382 "cfg_y.y"
        {
	    curr_sig->mode = sm_switch;
	}
#line 1745 "cfg_y.c"
    break;

  case 73: /* policy_item: TOK_LEVEL level  */
#line 389 "cfg_y.y"
        {
	    set_verbosity("POLICY",(yyvsp[0].num));
	}
#line 1753 "cfg_y.c"
    break;

  case 74: /* $@2: %empty  */
#line 393 "cfg_y.y"
        {
	    rule = alloc_t(RULE);
	    rule->type = (yyvsp[0].num);
	}
#line 1762 "cfg_y.c"
    break;

  case 76: /* action: TOK_ALLOW  */
#line 402 "cfg_y.y"
        {
	    (yyval.num) = ACL_ALLOW;
	}
#line 1770 "cfg_y.c"
    break;

  case 77: /* action: TOK_REJECT  */
#line 406 "cfg_y.y"
        {
	    (yyval.num) = ACL_REJECT;
	}
#line 1778 "cfg_y.c"
    break;

  case 78: /* direction: TOK_FROM  */
#line 413 "cfg_y.y"
        {
	    rule->type |= ACL_IN;
	    put_address((yyvsp[0].str));
	}
#line 1787 "cfg_y.c"
    break;

  case 79: /* direction: TOK_TO  */
#line 418 "cfg_y.y"
        {
	    rule->type |= ACL_OUT;
	    put_address((yyvsp[0].str));
	}
#line 1796 "cfg_y.c"
    break;


#line 1800 "cfg_y.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

